import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as core from '@mescius/wijmo';
import * as chart from '@mescius/wijmo.chart';
import * as animation from '@mescius/wijmo.chart.animation';
import { getData, getGroupData } from './data';
//
document.readyState === 'complete' ? init() : window.onload = init;
var barchart;
var view;
//
function init() {
view = getData();
barchart = new chart.FlexChart('#chart', {
legend: {
position: chart.Position.None
},
bindingX: 'name',
series: [{
binding: 'gdp',
name: 'GDP'
}],
axisX: {
title: 'Year',
format: 'd'
},
axisY: {
title: 'GDP (US$ in billions)'
},
tooltip: { content: '' },
selectionMode: chart.SelectionMode.Point,
selectionChanged: (s) => {
if (s.selection) {
let point = s.selection.collectionView.currentItem;
if (point && point.group && !point.group.isBottomLevel) {
showGroup(point.group);
}
}
},
itemsSource: getGroupData(view),
palette: ['rgba(45,159,199,1)', 'rgba(236,153,60,1)', 'rgba(137,194,53,1)', 'rgba(227,119,164,1)',
'rgba(166,137,49,1)', 'rgba(166,114,166,1)', 'rgba(208,192,65,1)', 'rgba(227,88,85,1)', 'rgba(104,112,106,1)']
});
//
let ani = new animation.ChartAnimation(barchart);
}
//
function showGroup(group) {
// update titles
updateChartHeader(group);
let level = 'level' in group ? group.level + 1 : 0;
barchart.axisX.title = core.toHeaderCase(view.groupDescriptions[level].propertyName);
//
// update the series color (use a different one for each level)
let palette = barchart.palette || chart.Palettes.standard;
barchart.series[0].style = {
fill: palette[level],
stroke: palette[level]
};
//
// update data
barchart.itemsSource = getGroupData(group);
barchart.selection = null;
}
//
// update the chart header element
var header = document.getElementById('header');
function updateChartHeader(group) {
let item = group.items[0], path = '', headers = [];
//
for (let i = 0; i <= group.level; i++) {
let prop = view.groupDescriptions[i].propertyName, hdr = core.format('<a href="#{path}">{prop}</a>: {value}', {
path: path,
prop: core.toHeaderCase(prop),
value: item[prop]
});
//
headers.push(hdr);
path += '/' + item[prop];
}
//
header.innerHTML = headers.length > 0
? 'IMF estimates GDP(nominal) GDP for ' + headers.join(', ')
: 'IMF estimates GDP(nominal) GDP';
}
//
// handle clicks on chart's header element to navigate back up
header.addEventListener('click', function (e) {
if (e.target.nodeName === 'A') {
e.preventDefault();
//
// get the link path
let path = e.target.href;
path = path.substr(path.lastIndexOf('#') + 1);
let paths = path.split('/');
//
// find the group that matches the path
let src = view;
for (let i = 1; i < paths.length; i++) {
for (let j = 0; j < src.groups.length; j++) {
let group = src.groups[j];
if (group.name == paths[i]) {
src = group;
break;
}
}
}
// show the selected group
showGroup(src);
}
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Column with Drill-down</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<h4 id="header">IMF estimates GDP(nominal) GDP</h4>
<div id="chart"></div>
</div>
</body>
</html>
// IMF estimates GDP(nominal) between 2020 and 2023
// https://en.wikipedia.org/wiki/List_of_countries_by_past_and_projected_GDP_(nominal)
import * as core from '@mescius/wijmo';
export function getData() {
let data = [
{ country: 'United States', continent: 'North America', year: 2020, gdp: 22289 },
{ country: 'United States', continent: 'North America', year: 2021, gdp: 23096 },
{ country: 'United States', continent: 'North America', year: 2022, gdp: 23874 },
{ country: 'United States', continent: 'North America', year: 2023, gdp: 24670 },
{ country: 'China', continent: 'Asia', year: 2020, gdp: 15461 },
{ country: 'China', continent: 'Asia', year: 2021, gdp: 16768 },
{ country: 'China', continent: 'Asia', year: 2022, gdp: 18131 },
{ country: 'China', continent: 'Asia', year: 2023, gdp: 19580 },
{ country: 'Japan', continent: 'Asia', year: 2020, gdp: 5371 },
{ country: 'Japan', continent: 'Asia', year: 2021, gdp: 5522 },
{ country: 'Japan', continent: 'Asia', year: 2022, gdp: 5714 },
{ country: 'Japan', continent: 'Asia', year: 2023, gdp: 5907 },
{ country: 'Gemany', continent: 'Europe', year: 2020, gdp: 4331 },
{ country: 'Gemany', continent: 'Europe', year: 2021, gdp: 4523 },
{ country: 'Gemany', continent: 'Europe', year: 2022, gdp: 4736 },
{ country: 'Gemany', continent: 'Europe', year: 2023, gdp: 4937 },
{ country: 'India', continent: 'Asia', year: 2020, gdp: 3258 },
{ country: 'India', continent: 'Asia', year: 2021, gdp: 3586 },
{ country: 'India', continent: 'Asia', year: 2022, gdp: 3941 },
{ country: 'India', continent: 'Asia', year: 2023, gdp: 4329 },
{ country: 'France', continent: 'Europe', year: 2020, gdp: 2979 },
{ country: 'France', continent: 'Europe', year: 2021, gdp: 3100 },
{ country: 'France', continent: 'Europe', year: 2022, gdp: 3234 },
{ country: 'France', continent: 'Europe', year: 2023, gdp: 3363 },
{ country: 'United Kindom', continent: 'Europe', year: 2020, gdp: 2912 },
{ country: 'United Kindom', continent: 'Europe', year: 2021, gdp: 3012 },
{ country: 'United Kindom', continent: 'Europe', year: 2022, gdp: 3135 },
{ country: 'United Kindom', continent: 'Europe', year: 2023, gdp: 3257 },
{ country: 'Italy', continent: 'Europe', year: 2020, gdp: 2191 },
{ country: 'Italy', continent: 'Europe', year: 2021, gdp: 2255 },
{ country: 'Italy', continent: 'Europe', year: 2022, gdp: 2329 },
{ country: 'Italy', continent: 'Europe', year: 2023, gdp: 2395 },
{ country: 'Brazil', continent: 'South America', year: 2020, gdp: 2027 },
{ country: 'Brazil', continent: 'South America', year: 2021, gdp: 2129 },
{ country: 'Brazil', continent: 'South America', year: 2022, gdp: 2237 },
{ country: 'Brazil', continent: 'South America', year: 2023, gdp: 2351 },
{ country: 'Canada', continent: 'North America', year: 2020, gdp: 1937 },
{ country: 'Canada', continent: 'North America', year: 2021, gdp: 2053 },
{ country: 'Canada', continent: 'North America', year: 2022, gdp: 2185 },
{ country: 'Canada', continent: 'North America', year: 2023, gdp: 2321 },
{ country: 'South Korea', continent: 'Asia', year: 2020, gdp: 1781 },
{ country: 'South Korea', continent: 'Asia', year: 2021, gdp: 1864 },
{ country: 'South Korea', continent: 'Asia', year: 2022, gdp: 1959 },
{ country: 'South Korea', continent: 'Asia', year: 2023, gdp: 2054 },
{ country: 'Russia', continent: 'Europe', year: 2020, gdp: 1683 },
{ country: 'Russia', continent: 'Europe', year: 2021, gdp: 1719 },
{ country: 'Russia', continent: 'Europe', year: 2022, gdp: 1757 },
{ country: 'Russia', continent: 'Europe', year: 2023, gdp: 1818 },
{ country: 'Spain', continent: 'Europe', year: 2020, gdp: 1550 },
{ country: 'Spain', continent: 'Europe', year: 2021, gdp: 1616 },
{ country: 'Spain', continent: 'Europe', year: 2022, gdp: 1690 },
{ country: 'Spain', continent: 'Europe', year: 2023, gdp: 1758 },
{ country: 'Australia', continent: 'Oceania', year: 2020, gdp: 1541 },
{ country: 'Australia', continent: 'Oceania', year: 2021, gdp: 1615 },
{ country: 'Australia', continent: 'Oceania', year: 2022, gdp: 1700 },
{ country: 'Australia', continent: 'Oceania', year: 2023, gdp: 1794 },
{ country: 'Mexico', continent: 'North America', year: 2020, gdp: 1306 },
{ country: 'Mexico', continent: 'North America', year: 2021, gdp: 1376 },
{ country: 'Mexico', continent: 'North America', year: 2022, gdp: 1449 },
{ country: 'Mexico', continent: 'North America', year: 2023, gdp: 1526 },
{ country: 'Indonesia', continent: 'Asia', year: 2020, gdp: 1175 },
{ country: 'Indonesia', continent: 'Asia', year: 2021, gdp: 1259 },
{ country: 'Indonesia', continent: 'Asia', year: 2022, gdp: 1349 },
{ country: 'Indonesia', continent: 'Asia', year: 2023, gdp: 1446 },
{ country: 'Netherlands', continent: 'Europe', year: 2020, gdp: 980 },
{ country: 'Netherlands', continent: 'Europe', year: 2021, gdp: 1021 },
{ country: 'Netherlands', continent: 'Europe', year: 2022, gdp: 1065 },
{ country: 'Netherlands', continent: 'Europe', year: 2023, gdp: 1106 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2020, gdp: 815 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2021, gdp: 835 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2022, gdp: 860 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2023, gdp: 889 },
{ country: 'Nigeria', continent: 'Africa', year: 2020, gdp: 504 },
{ country: 'Nigeria', continent: 'Africa', year: 2021, gdp: 572 },
{ country: 'Nigeria', continent: 'Africa', year: 2022, gdp: 649 },
{ country: 'Nigeria', continent: 'Africa', year: 2023, gdp: 736 },
{ country: 'Argentina', continent: 'South America', year: 2020, gdp: 444 },
{ country: 'Argentina', continent: 'South America', year: 2021, gdp: 476 },
{ country: 'Argentina', continent: 'South America', year: 2022, gdp: 508 },
{ country: 'Argentina', continent: 'South America', year: 2023, gdp: 540 },
{ country: 'South Africa', continent: 'South America', year: 2020, gdp: 403 },
{ country: 'South Africa', continent: 'South America', year: 2021, gdp: 419 },
{ country: 'South Africa', continent: 'South America', year: 2022, gdp: 438 },
{ country: 'South Africa', continent: 'South America', year: 2023, gdp: 456 },
{ country: 'Colombia', continent: 'South America', year: 2020, gdp: 367 },
{ country: 'Colombia', continent: 'South America', year: 2021, gdp: 382 },
{ country: 'Colombia', continent: 'South America', year: 2022, gdp: 400 },
{ country: 'Colombia', continent: 'South America', year: 2023, gdp: 422 },
{ country: 'Chile', continent: 'South America', year: 2020, gdp: 352 },
{ country: 'Chile', continent: 'South America', year: 2021, gdp: 378 },
{ country: 'Chile', continent: 'South America', year: 2022, gdp: 404 },
{ country: 'Chile', continent: 'South America', year: 2023, gdp: 433 },
{ country: 'Egypt', continent: 'Africa', year: 2020, gdp: 339 },
{ country: 'Egypt', continent: 'Africa', year: 2021, gdp: 359 },
{ country: 'Egypt', continent: 'Africa', year: 2022, gdp: 380 },
{ country: 'Egypt', continent: 'Africa', year: 2023, gdp: 414 },
{ country: 'Peru', continent: 'South America', year: 2020, gdp: 252 },
{ country: 'Peru', continent: 'South America', year: 2021, gdp: 266 },
{ country: 'Peru', continent: 'South America', year: 2022, gdp: 281 },
{ country: 'Peru', continent: 'South America', year: 2023, gdp: 297 },
{ country: 'New Zealand', continent: 'Oceania', year: 2020, gdp: 227 },
{ country: 'New Zealand', continent: 'Oceania', year: 2021, gdp: 242 },
{ country: 'New Zealand', continent: 'Oceania', year: 2022, gdp: 257 },
{ country: 'New Zealand', continent: 'Oceania', year: 2023, gdp: 272 },
{ country: 'Algeria', continent: 'Africa', year: 2020, gdp: 207 },
{ country: 'Algeria', continent: 'Africa', year: 2021, gdp: 212 },
{ country: 'Algeria', continent: 'Africa', year: 2022, gdp: 218 },
{ country: 'Algeria', continent: 'Africa', year: 2023, gdp: 228 }
];
//
return new core.CollectionView(data, {
groupDescriptions: ['year', 'continent', 'country']
});
}
//
// get the group data for a selected point
export function getGroupData(group) {
// get items for this group, aggregate by sales
let arr = [];
//
group.groups.forEach(g => {
arr.push({
name: g.name,
gdp: g.getAggregate(core.Aggregate.Sum, 'gdp'),
group: g
});
});
//
// return a new collection view sorted by sales
return new core.CollectionView(arr, {
sortDescriptions: [
new core.SortDescription('gdp', false)
]
});
}
body {
margin-bottom: 24px;
}
.container h4 {
text-align: center;
}
.container a {
cursor: pointer;
}
.container .wj-flexchart {
border: none;
}
.container {
border: 1px solid #e4e4e4;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef } from 'react';
import useEvent from 'react-use-event-hook';
import * as wijmo from '@mescius/wijmo';
import * as wjChart from '@mescius/wijmo.react.chart';
import * as wjCharts from '@mescius/wijmo.chart';
import * as wjChartAnimate from '@mescius/wijmo.react.chart.animation';
import './app.css';
import { data, getGroupData, groupedViewData, palette } from './data';
function App() {
const chartRef = useRef(null);
const headerRef = useRef(null);
const initializeChart = useEvent((flex) => {
chartRef.current = flex;
headerRef.current = document.querySelector('#header');
headerRef.current.addEventListener('click', (e) => handleHeaderClick(e));
});
const selectionChanged = useEvent(() => {
if (chartRef.current.selection) {
let point = chartRef.current.selection.collectionView.currentItem;
if (point && point.group && !point.group.isBottomLevel) {
showGroup(point.group);
}
}
});
const handleHeaderClick = (e) => {
if (e.target.nodeName === 'A') {
e.preventDefault();
// get the link path
let path = e.target.href;
path = path.substr(path.lastIndexOf('#') + 1);
let paths = path.split('/');
// find the group that matches the path
let src = data;
for (let i = 1; i < paths.length; i++) {
for (let j = 0; j < src.groups.length; j++) {
let group = src.groups[j];
if (group.name == paths[i]) {
src = group;
break;
}
}
}
// show the selected group
showGroup(src);
}
};
const showGroup = (group) => {
updateChartHeader(group);
var level = 'level' in group ? group.level + 1 : 0;
chartRef.current.axisX.title = wijmo.toHeaderCase(data.groupDescriptions[level].propertyName);
// update the series color (use a different one for each level)
var palette = chartRef.current.palette || wjCharts.Palettes.standard;
chartRef.current.series[0].style = {
fill: palette[level],
stroke: palette[level]
};
//
// update data
chartRef.current.itemsSource = getGroupData(group);
chartRef.current.selection = null;
};
const updateChartHeader = (group) => {
let item = group.items[0], path = '', headers = [];
//
for (let i = 0; i <= group.level; i++) {
let prop = data.groupDescriptions[i].propertyName, hdr = wijmo.format('<a href="#{path}">{prop}</a>: {value}', {
path: path,
prop: wijmo.toHeaderCase(prop),
value: item[prop]
});
headers.push(hdr);
path += '/' + item[prop];
}
//
headerRef.current.innerHTML = headers.length > 0
? 'IMF estimates GDP(nominal) GDP for ' + headers.join(', ')
: 'IMF estimates GDP(nominal) GDP';
};
return (<div className="container-fluid">
<h4 id="header">IMF estimates GDP(nominal) GDP</h4>
<wjChart.FlexChart bindingX="name" selectionMode="Point" itemsSource={groupedViewData} selectionChanged={selectionChanged} initialized={initializeChart} tooltipContent="" palette={palette}>
<wjChart.FlexChartLegend position="None"/>
<wjChart.FlexChartSeries name="GDP" binding="gdp"/>
<wjChart.FlexChartAxis wjProperty="axisX" format="d" title="Year"/>
<wjChart.FlexChartAxis wjProperty="axisY" title="GDP (US$ in billions)"/>
<wjChartAnimate.FlexChartAnimation />
</wjChart.FlexChart>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexChart Column with Drill-down</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.container-fluid {
border: 1px solid #e4e4e4;
}
.container-fluid .wj-flexchart {
border: none;
}
.container-fluid a {
cursor: pointer;
}
import * as wijmo from '@mescius/wijmo';
//Comparison of imports vs exports of the United States https://en.wikipedia.org/wiki/Comparison_of_imports_vs_exports_of_the_United_States
function getData() {
let data = [
{ country: 'United States', continent: 'North America', year: 2020, gdp: 22289 },
{ country: 'United States', continent: 'North America', year: 2021, gdp: 23096 },
{ country: 'United States', continent: 'North America', year: 2022, gdp: 23874 },
{ country: 'United States', continent: 'North America', year: 2023, gdp: 24670 },
{ country: 'China', continent: 'Asia', year: 2020, gdp: 15461 },
{ country: 'China', continent: 'Asia', year: 2021, gdp: 16768 },
{ country: 'China', continent: 'Asia', year: 2022, gdp: 18131 },
{ country: 'China', continent: 'Asia', year: 2023, gdp: 19580 },
{ country: 'Japan', continent: 'Asia', year: 2020, gdp: 5371 },
{ country: 'Japan', continent: 'Asia', year: 2021, gdp: 5522 },
{ country: 'Japan', continent: 'Asia', year: 2022, gdp: 5714 },
{ country: 'Japan', continent: 'Asia', year: 2023, gdp: 5907 },
{ country: 'Gemany', continent: 'Europe', year: 2020, gdp: 4331 },
{ country: 'Gemany', continent: 'Europe', year: 2021, gdp: 4523 },
{ country: 'Gemany', continent: 'Europe', year: 2022, gdp: 4736 },
{ country: 'Gemany', continent: 'Europe', year: 2023, gdp: 4937 },
{ country: 'India', continent: 'Asia', year: 2020, gdp: 3258 },
{ country: 'India', continent: 'Asia', year: 2021, gdp: 3586 },
{ country: 'India', continent: 'Asia', year: 2022, gdp: 3941 },
{ country: 'India', continent: 'Asia', year: 2023, gdp: 4329 },
{ country: 'France', continent: 'Europe', year: 2020, gdp: 2979 },
{ country: 'France', continent: 'Europe', year: 2021, gdp: 3100 },
{ country: 'France', continent: 'Europe', year: 2022, gdp: 3234 },
{ country: 'France', continent: 'Europe', year: 2023, gdp: 3363 },
{ country: 'United Kindom', continent: 'Europe', year: 2020, gdp: 2912 },
{ country: 'United Kindom', continent: 'Europe', year: 2021, gdp: 3012 },
{ country: 'United Kindom', continent: 'Europe', year: 2022, gdp: 3135 },
{ country: 'United Kindom', continent: 'Europe', year: 2023, gdp: 3257 },
{ country: 'Italy', continent: 'Europe', year: 2020, gdp: 2191 },
{ country: 'Italy', continent: 'Europe', year: 2021, gdp: 2255 },
{ country: 'Italy', continent: 'Europe', year: 2022, gdp: 2329 },
{ country: 'Italy', continent: 'Europe', year: 2023, gdp: 2395 },
{ country: 'Brazil', continent: 'South America', year: 2020, gdp: 2027 },
{ country: 'Brazil', continent: 'South America', year: 2021, gdp: 2129 },
{ country: 'Brazil', continent: 'South America', year: 2022, gdp: 2237 },
{ country: 'Brazil', continent: 'South America', year: 2023, gdp: 2351 },
{ country: 'Canada', continent: 'North America', year: 2020, gdp: 1937 },
{ country: 'Canada', continent: 'North America', year: 2021, gdp: 2053 },
{ country: 'Canada', continent: 'North America', year: 2022, gdp: 2185 },
{ country: 'Canada', continent: 'North America', year: 2023, gdp: 2321 },
{ country: 'South Korea', continent: 'Asia', year: 2020, gdp: 1781 },
{ country: 'South Korea', continent: 'Asia', year: 2021, gdp: 1864 },
{ country: 'South Korea', continent: 'Asia', year: 2022, gdp: 1959 },
{ country: 'South Korea', continent: 'Asia', year: 2023, gdp: 2054 },
{ country: 'Russia', continent: 'Europe', year: 2020, gdp: 1683 },
{ country: 'Russia', continent: 'Europe', year: 2021, gdp: 1719 },
{ country: 'Russia', continent: 'Europe', year: 2022, gdp: 1757 },
{ country: 'Russia', continent: 'Europe', year: 2023, gdp: 1818 },
{ country: 'Spain', continent: 'Europe', year: 2020, gdp: 1550 },
{ country: 'Spain', continent: 'Europe', year: 2021, gdp: 1616 },
{ country: 'Spain', continent: 'Europe', year: 2022, gdp: 1690 },
{ country: 'Spain', continent: 'Europe', year: 2023, gdp: 1758 },
{ country: 'Australia', continent: 'Oceania', year: 2020, gdp: 1541 },
{ country: 'Australia', continent: 'Oceania', year: 2021, gdp: 1615 },
{ country: 'Australia', continent: 'Oceania', year: 2022, gdp: 1700 },
{ country: 'Australia', continent: 'Oceania', year: 2023, gdp: 1794 },
{ country: 'Mexico', continent: 'North America', year: 2020, gdp: 1306 },
{ country: 'Mexico', continent: 'North America', year: 2021, gdp: 1376 },
{ country: 'Mexico', continent: 'North America', year: 2022, gdp: 1449 },
{ country: 'Mexico', continent: 'North America', year: 2023, gdp: 1526 },
{ country: 'Indonesia', continent: 'Asia', year: 2020, gdp: 1175 },
{ country: 'Indonesia', continent: 'Asia', year: 2021, gdp: 1259 },
{ country: 'Indonesia', continent: 'Asia', year: 2022, gdp: 1349 },
{ country: 'Indonesia', continent: 'Asia', year: 2023, gdp: 1446 },
{ country: 'Netherlands', continent: 'Europe', year: 2020, gdp: 980 },
{ country: 'Netherlands', continent: 'Europe', year: 2021, gdp: 1021 },
{ country: 'Netherlands', continent: 'Europe', year: 2022, gdp: 1065 },
{ country: 'Netherlands', continent: 'Europe', year: 2023, gdp: 1106 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2020, gdp: 815 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2021, gdp: 835 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2022, gdp: 860 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2023, gdp: 889 },
{ country: 'Nigeria', continent: 'Africa', year: 2020, gdp: 504 },
{ country: 'Nigeria', continent: 'Africa', year: 2021, gdp: 572 },
{ country: 'Nigeria', continent: 'Africa', year: 2022, gdp: 649 },
{ country: 'Nigeria', continent: 'Africa', year: 2023, gdp: 736 },
{ country: 'Argentina', continent: 'South America', year: 2020, gdp: 444 },
{ country: 'Argentina', continent: 'South America', year: 2021, gdp: 476 },
{ country: 'Argentina', continent: 'South America', year: 2022, gdp: 508 },
{ country: 'Argentina', continent: 'South America', year: 2023, gdp: 540 },
{ country: 'South Africa', continent: 'South America', year: 2020, gdp: 403 },
{ country: 'South Africa', continent: 'South America', year: 2021, gdp: 419 },
{ country: 'South Africa', continent: 'South America', year: 2022, gdp: 438 },
{ country: 'South Africa', continent: 'South America', year: 2023, gdp: 456 },
{ country: 'Colombia', continent: 'South America', year: 2020, gdp: 367 },
{ country: 'Colombia', continent: 'South America', year: 2021, gdp: 382 },
{ country: 'Colombia', continent: 'South America', year: 2022, gdp: 400 },
{ country: 'Colombia', continent: 'South America', year: 2023, gdp: 422 },
{ country: 'Chile', continent: 'South America', year: 2020, gdp: 352 },
{ country: 'Chile', continent: 'South America', year: 2021, gdp: 378 },
{ country: 'Chile', continent: 'South America', year: 2022, gdp: 404 },
{ country: 'Chile', continent: 'South America', year: 2023, gdp: 433 },
{ country: 'Egypt', continent: 'Africa', year: 2020, gdp: 339 },
{ country: 'Egypt', continent: 'Africa', year: 2021, gdp: 359 },
{ country: 'Egypt', continent: 'Africa', year: 2022, gdp: 380 },
{ country: 'Egypt', continent: 'Africa', year: 2023, gdp: 414 },
{ country: 'Peru', continent: 'South America', year: 2020, gdp: 252 },
{ country: 'Peru', continent: 'South America', year: 2021, gdp: 266 },
{ country: 'Peru', continent: 'South America', year: 2022, gdp: 281 },
{ country: 'Peru', continent: 'South America', year: 2023, gdp: 297 },
{ country: 'New Zealand', continent: 'Oceania', year: 2020, gdp: 227 },
{ country: 'New Zealand', continent: 'Oceania', year: 2021, gdp: 242 },
{ country: 'New Zealand', continent: 'Oceania', year: 2022, gdp: 257 },
{ country: 'New Zealand', continent: 'Oceania', year: 2023, gdp: 272 },
{ country: 'Algeria', continent: 'Africa', year: 2020, gdp: 207 },
{ country: 'Algeria', continent: 'Africa', year: 2021, gdp: 212 },
{ country: 'Algeria', continent: 'Africa', year: 2022, gdp: 218 },
{ country: 'Algeria', continent: 'Africa', year: 2023, gdp: 228 }
];
//
return new wijmo.CollectionView(data, {
groupDescriptions: ['year', 'continent', 'country']
});
}
export function getGroupData(group) {
// get items for this group, aggregate by sales
let arr = [];
group.groups.forEach(function (g) {
arr.push({
name: g.name,
gdp: g.getAggregate(wijmo.Aggregate.Sum, 'gdp'),
group: g
});
});
//
// return a new collection view sorted by sales
return new wijmo.CollectionView(arr, {
sortDescriptions: [
new wijmo.SortDescription('gdp', false)
]
});
}
export const palette = ['rgba(45,159,199,1)', 'rgba(236,153,60,1)', 'rgba(137,194,53,1)', 'rgba(227,119,164,1)', 'rgba(166,137,49,1)', 'rgba(166,114,166,1)', 'rgba(208,192,65,1)', 'rgba(227,88,85,1)', 'rgba(104,112,106,1)'];
export const data = getData();
export const groupedViewData = getGroupData(data);
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import * as wijmo from '@mescius/wijmo';
import * as chart from '@mescius/wijmo.chart';
import '@angular/compiler';
import {
Component,
Inject,
enableProdMode,
ViewChild,
OnInit,
ElementRef,
ɵresolveComponentResources,
} from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjChartModule } from '@mescius/wijmo.angular2.chart';
import { WjChartAnimationModule } from '@mescius/wijmo.angular2.chart.animation';
import { DataService } from './app.data';
@Component({
standalone: true,
providers: [DataService],
imports: [WjChartModule, WjChartAnimationModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent implements OnInit {
@ViewChild('flexChart', { static: true }) private _flexChart: chart.FlexChart;
@ViewChild('header', { static: true }) private _header: ElementRef;
private _view: wijmo.CollectionView;
groupedView: wijmo.CollectionView;
constructor(@Inject(DataService) private dataService: DataService) {
this._view = dataService.getData();
this.groupedView = dataService.getGroupData(this._view);
}
ngOnInit() {
this._header.nativeElement.addEventListener('click', (e: MouseEvent) => this._onHeaderClick(e));
}
selectionChanged(flexChart: chart.FlexChart) {
if (flexChart.selection) {
let point = flexChart.selection.collectionView.currentItem;
if (point && point.group && !point.group.isBottomLevel) {
this.showGroup(point.group);
}
}
}
showGroup(group: wijmo.CollectionViewGroup) {
// update titles
this._updateChartHeader(group);
let level = 'level' in group ? group.level + 1 : 0,
pgd = this._view.groupDescriptions[level] as wijmo.PropertyGroupDescription;
this._flexChart.axisX.title = wijmo.toHeaderCase(pgd.propertyName);
// update the series color (use a different one for each level)
var palette = this._flexChart.palette || chart.Palettes.standard;
this._flexChart.series[0].style = {
fill: palette[level],
stroke: palette[level],
};
// update data
this._flexChart.itemsSource = this.dataService.getGroupData(group);
this._flexChart.selection = null;
}
//
private _onHeaderClick(e: Event) {
if ((<Node>e.target).nodeName === 'A') {
e.preventDefault();
// get the link path
let path = (<HTMLAnchorElement>e.target).href;
path = path.substr(path.lastIndexOf('#') + 1);
let paths = path.split('/');
// find the group that matches the path
let src: any = this._view;
for (let i = 1; i < paths.length; i++) {
for (let j = 0; j < src.groups.length; j++) {
let group = src.groups[j];
if (group.name == paths[i]) {
src = group;
break;
}
}
}
// show the selected group
this.showGroup(src);
}
}
private _updateChartHeader(group: wijmo.CollectionViewGroup) {
let item = group.items[0],
path = '',
headers = [];
for (let i = 0; i <= group.level; i++) {
let pgd = this._view.groupDescriptions[i] as wijmo.PropertyGroupDescription,
prop = pgd.propertyName,
hdr = wijmo.format('<a href="#{path}">{prop}</a>: {value}', {
path: path,
prop: wijmo.toHeaderCase(prop),
value: item[prop],
});
headers.push(hdr);
path += '/' + item[prop];
}
this._header.nativeElement.innerHTML =
headers.length > 0
? 'IMF estimates GDP(nominal) GDP for ' + headers.join(', ')
: 'IMF estimates GDP(nominal) GDP';
}
}
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Column with Drill-down</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<h4 #header>IMF estimates GDP(nominal) GDP</h4>
<wj-flex-chart #flexChart [bindingX]="'name'" [selectionMode]="'Point'" [itemsSource]="groupedView" [tooltipContent]="''"
(selectionChanged)="selectionChanged(flexChart)"
[palette]="['rgba(45,159,199,1)', 'rgba(236,153,60,1)', 'rgba(137,194,53,1)', 'rgba(227,119,164,1)', 'rgba(166,137,49,1)', 'rgba(166,114,166,1)', 'rgba(208,192,65,1)', 'rgba(227,88,85,1)', 'rgba(104,112,106,1)']">
<wj-flex-chart-legend [position]="'None'">
</wj-flex-chart-legend>
<wj-flex-chart-series [name]="'GDP'" [binding]="'gdp'">
</wj-flex-chart-series>
<wj-flex-chart-axis [wjProperty]="'axisX'" [format]="'d'" [title]="'Year'">
</wj-flex-chart-axis>
<wj-flex-chart-axis [wjProperty]="'axisY'" [title]="'GDP (US$ in billions)'">
</wj-flex-chart-axis>
<wj-flex-chart-animation></wj-flex-chart-animation>
</wj-flex-chart>
</div>
import { Injectable } from '@angular/core';
import * as wijmo from '@mescius/wijmo';
//
@Injectable()
export class DataService {
// IMF estimates GDP(nominal) between 2020 and 2023
// https://en.wikipedia.org/wiki/List_of_countries_by_past_and_projected_GDP_(nominal)
getData() {
let data = [
{ country: 'United States', continent: 'North America', year: 2020, gdp: 22289 },
{ country: 'United States', continent: 'North America', year: 2021, gdp: 23096 },
{ country: 'United States', continent: 'North America', year: 2022, gdp: 23874 },
{ country: 'United States', continent: 'North America', year: 2023, gdp: 24670 },
{ country: 'China', continent: 'Asia', year: 2020, gdp: 15461 },
{ country: 'China', continent: 'Asia', year: 2021, gdp: 16768 },
{ country: 'China', continent: 'Asia', year: 2022, gdp: 18131 },
{ country: 'China', continent: 'Asia', year: 2023, gdp: 19580 },
{ country: 'Japan', continent: 'Asia', year: 2020, gdp: 5371 },
{ country: 'Japan', continent: 'Asia', year: 2021, gdp: 5522 },
{ country: 'Japan', continent: 'Asia', year: 2022, gdp: 5714 },
{ country: 'Japan', continent: 'Asia', year: 2023, gdp: 5907 },
{ country: 'Gemany', continent: 'Europe', year: 2020, gdp: 4331 },
{ country: 'Gemany', continent: 'Europe', year: 2021, gdp: 4523 },
{ country: 'Gemany', continent: 'Europe', year: 2022, gdp: 4736 },
{ country: 'Gemany', continent: 'Europe', year: 2023, gdp: 4937 },
{ country: 'India', continent: 'Asia', year: 2020, gdp: 3258 },
{ country: 'India', continent: 'Asia', year: 2021, gdp: 3586 },
{ country: 'India', continent: 'Asia', year: 2022, gdp: 3941 },
{ country: 'India', continent: 'Asia', year: 2023, gdp: 4329 },
{ country: 'France', continent: 'Europe', year: 2020, gdp: 2979 },
{ country: 'France', continent: 'Europe', year: 2021, gdp: 3100 },
{ country: 'France', continent: 'Europe', year: 2022, gdp: 3234 },
{ country: 'France', continent: 'Europe', year: 2023, gdp: 3363 },
{ country: 'United Kindom', continent: 'Europe', year: 2020, gdp: 2912 },
{ country: 'United Kindom', continent: 'Europe', year: 2021, gdp: 3012 },
{ country: 'United Kindom', continent: 'Europe', year: 2022, gdp: 3135 },
{ country: 'United Kindom', continent: 'Europe', year: 2023, gdp: 3257 },
{ country: 'Italy', continent: 'Europe', year: 2020, gdp: 2191 },
{ country: 'Italy', continent: 'Europe', year: 2021, gdp: 2255 },
{ country: 'Italy', continent: 'Europe', year: 2022, gdp: 2329 },
{ country: 'Italy', continent: 'Europe', year: 2023, gdp: 2395 },
{ country: 'Brazil', continent: 'South America', year: 2020, gdp: 2027 },
{ country: 'Brazil', continent: 'South America', year: 2021, gdp: 2129 },
{ country: 'Brazil', continent: 'South America', year: 2022, gdp: 2237 },
{ country: 'Brazil', continent: 'South America', year: 2023, gdp: 2351 },
{ country: 'Canada', continent: 'North America', year: 2020, gdp: 1937 },
{ country: 'Canada', continent: 'North America', year: 2021, gdp: 2053 },
{ country: 'Canada', continent: 'North America', year: 2022, gdp: 2185 },
{ country: 'Canada', continent: 'North America', year: 2023, gdp: 2321 },
{ country: 'South Korea', continent: 'Asia', year: 2020, gdp: 1781 },
{ country: 'South Korea', continent: 'Asia', year: 2021, gdp: 1864 },
{ country: 'South Korea', continent: 'Asia', year: 2022, gdp: 1959 },
{ country: 'South Korea', continent: 'Asia', year: 2023, gdp: 2054 },
{ country: 'Russia', continent: 'Europe', year: 2020, gdp: 1683 },
{ country: 'Russia', continent: 'Europe', year: 2021, gdp: 1719 },
{ country: 'Russia', continent: 'Europe', year: 2022, gdp: 1757 },
{ country: 'Russia', continent: 'Europe', year: 2023, gdp: 1818 },
{ country: 'Spain', continent: 'Europe', year: 2020, gdp: 1550 },
{ country: 'Spain', continent: 'Europe', year: 2021, gdp: 1616 },
{ country: 'Spain', continent: 'Europe', year: 2022, gdp: 1690 },
{ country: 'Spain', continent: 'Europe', year: 2023, gdp: 1758 },
{ country: 'Australia', continent: 'Oceania', year: 2020, gdp: 1541 },
{ country: 'Australia', continent: 'Oceania', year: 2021, gdp: 1615 },
{ country: 'Australia', continent: 'Oceania', year: 2022, gdp: 1700 },
{ country: 'Australia', continent: 'Oceania', year: 2023, gdp: 1794 },
{ country: 'Mexico', continent: 'North America', year: 2020, gdp: 1306 },
{ country: 'Mexico', continent: 'North America', year: 2021, gdp: 1376 },
{ country: 'Mexico', continent: 'North America', year: 2022, gdp: 1449 },
{ country: 'Mexico', continent: 'North America', year: 2023, gdp: 1526 },
{ country: 'Indonesia', continent: 'Asia', year: 2020, gdp: 1175 },
{ country: 'Indonesia', continent: 'Asia', year: 2021, gdp: 1259 },
{ country: 'Indonesia', continent: 'Asia', year: 2022, gdp: 1349 },
{ country: 'Indonesia', continent: 'Asia', year: 2023, gdp: 1446 },
{ country: 'Netherlands', continent: 'Europe', year: 2020, gdp: 980 },
{ country: 'Netherlands', continent: 'Europe', year: 2021, gdp: 1021 },
{ country: 'Netherlands', continent: 'Europe', year: 2022, gdp: 1065 },
{ country: 'Netherlands', continent: 'Europe', year: 2023, gdp: 1106 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2020, gdp: 815 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2021, gdp: 835 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2022, gdp: 860 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2023, gdp: 889 },
{ country: 'Nigeria', continent: 'Africa', year: 2020, gdp: 504 },
{ country: 'Nigeria', continent: 'Africa', year: 2021, gdp: 572 },
{ country: 'Nigeria', continent: 'Africa', year: 2022, gdp: 649 },
{ country: 'Nigeria', continent: 'Africa', year: 2023, gdp: 736 },
{ country: 'Argentina', continent: 'South America', year: 2020, gdp: 444 },
{ country: 'Argentina', continent: 'South America', year: 2021, gdp: 476 },
{ country: 'Argentina', continent: 'South America', year: 2022, gdp: 508 },
{ country: 'Argentina', continent: 'South America', year: 2023, gdp: 540 },
{ country: 'South Africa', continent: 'South America', year: 2020, gdp: 403 },
{ country: 'South Africa', continent: 'South America', year: 2021, gdp: 419 },
{ country: 'South Africa', continent: 'South America', year: 2022, gdp: 438 },
{ country: 'South Africa', continent: 'South America', year: 2023, gdp: 456 },
{ country: 'Colombia', continent: 'South America', year: 2020, gdp: 367 },
{ country: 'Colombia', continent: 'South America', year: 2021, gdp: 382 },
{ country: 'Colombia', continent: 'South America', year: 2022, gdp: 400 },
{ country: 'Colombia', continent: 'South America', year: 2023, gdp: 422 },
{ country: 'Chile', continent: 'South America', year: 2020, gdp: 352 },
{ country: 'Chile', continent: 'South America', year: 2021, gdp: 378 },
{ country: 'Chile', continent: 'South America', year: 2022, gdp: 404 },
{ country: 'Chile', continent: 'South America', year: 2023, gdp: 433 },
{ country: 'Egypt', continent: 'Africa', year: 2020, gdp: 339 },
{ country: 'Egypt', continent: 'Africa', year: 2021, gdp: 359 },
{ country: 'Egypt', continent: 'Africa', year: 2022, gdp: 380 },
{ country: 'Egypt', continent: 'Africa', year: 2023, gdp: 414 },
{ country: 'Peru', continent: 'South America', year: 2020, gdp: 252 },
{ country: 'Peru', continent: 'South America', year: 2021, gdp: 266 },
{ country: 'Peru', continent: 'South America', year: 2022, gdp: 281 },
{ country: 'Peru', continent: 'South America', year: 2023, gdp: 297 },
{ country: 'New Zealand', continent: 'Oceania', year: 2020, gdp: 227 },
{ country: 'New Zealand', continent: 'Oceania', year: 2021, gdp: 242 },
{ country: 'New Zealand', continent: 'Oceania', year: 2022, gdp: 257 },
{ country: 'New Zealand', continent: 'Oceania', year: 2023, gdp: 272 },
{ country: 'Algeria', continent: 'Africa', year: 2020, gdp: 207 },
{ country: 'Algeria', continent: 'Africa', year: 2021, gdp: 212 },
{ country: 'Algeria', continent: 'Africa', year: 2022, gdp: 218 },
{ country: 'Algeria', continent: 'Africa', year: 2023, gdp: 228 }
];
//
return new wijmo.CollectionView(data, {
groupDescriptions: ['year', 'continent', 'country']
});
}
//
// get the group data for a selected point
getGroupData(group: wijmo.CollectionView | wijmo.CollectionViewGroup) {
// get items for this group, aggregate by sales
let arr: any[] = [];
group.groups.forEach(function (g) {
arr.push({
name: g.name,
gdp: g.getAggregate(wijmo.Aggregate.Sum, 'gdp'),
group: g
});
});
//
// return a new collection view sorted by sales
return new wijmo.CollectionView(arr, {
sortDescriptions: [
new wijmo.SortDescription('gdp', false)
]
});
}
}
body {
margin-bottom: 24px;
}
.container h4 {
text-align: center;
}
.container a {
cursor: pointer;
}
.container .wj-flexchart {
border: none;
}
.container {
border: 1px solid #e4e4e4;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

<template>
<div class="container-fluid">
<h4 id="header">IMF estimates GDP(nominal) GDP</h4>
<wj-flex-chart bindingX="name" selectionMode="Point" :itemsSource="groupedViewData"
:selectionChanged="selectionChanged" :initialized="initializeChart" tooltipContent=""
:palette="['rgba(45,159,199,1)', 'rgba(236,153,60,1)', 'rgba(137,194,53,1)', 'rgba(227,119,164,1)', 'rgba(166,137,49,1)', 'rgba(166,114,166,1)', 'rgba(208,192,65,1)', 'rgba(227,88,85,1)', 'rgba(104,112,106,1)']">
<wj-flex-chart-legend position="None"></wj-flex-chart-legend>
<wj-flex-chart-series name="GDP" binding="gdp"></wj-flex-chart-series>
<wj-flex-chart-axis wjProperty="axisX" format="d" title="Year"></wj-flex-chart-axis>
<wj-flex-chart-axis wjProperty="axisY" title="GDP (US$ in billions)"></wj-flex-chart-axis>
<wj-flex-chart-animation></wj-flex-chart-animation>
</wj-flex-chart>
</div>
</template>
<script setup>
import { getData, getGroupData } from "./data";
import { ref } from "vue";
const data = ref(getData());
const groupedViewData = ref(null);
const theChart = ref(null);
const header = ref(null);
function initializeChart(flex) {
theChart.value = flex;
header.value = document.querySelector("#header");
header.value.addEventListener("click", (e) => _onHeaderClick(e));
groupedViewData.value = getGroupData(data.value);
}
function selectionChanged() {
if (theChart.value.selection) {
let point = theChart.value.selection.collectionView.currentItem;
if (point && point.group && !point.group.isBottomLevel) {
showGroup(point.group);
}
}
}
function _onHeaderClick(e) {
if (e.target.nodeName === "A") {
e.preventDefault();
//
// get the link path
let path = e.target.href;
path = path.substr(path.lastIndexOf("#") + 1);
let paths = path.split("/");
//
// find the group that matches the path
let src = data.value;
for (let i = 1; i < paths.length; i++) {
for (let j = 0; j < src.groups.length; j++) {
let group = src.groups[j];
if (group.name == paths[i]) {
src = group;
break;
}
}
}
// show the selected group
showGroup(src);
}
}
function showGroup(group) {
// update titles
_updateChartHeader(group);
var level = "level" in group ? group.level + 1 : 0;
theChart.value.axisX.title = wijmo.toHeaderCase(data.value.groupDescriptions[level].propertyName);
//
// update the series color (use a different one for each level)
var palette = theChart.value.palette || chart.Palettes.standard;
theChart.value.series[0].style = {
fill: palette[level],
stroke: palette[level],
};
//
// update data
theChart.value.itemsSource = getGroupData(group);
theChart.value.selection = null;
}
function _updateChartHeader(group) {
let item = group.items[0],
path = "",
headers = [];
//
for (let i = 0; i <= group.level; i++) {
let prop = data.value.groupDescriptions[i].propertyName,
hdr = wijmo.format('<a href="#{path}">{prop}</a>: {value}', {
path: path,
prop: wijmo.toHeaderCase(prop),
value: item[prop],
});
headers.push(hdr);
path += "/" + item[prop];
}
//
header.value.innerHTML = headers.length > 0 ? "IMF estimates GDP(nominal) GDP for " + headers.join(", ") : "IMF estimates GDP(nominal) GDP";
}
</script>
<style>
body {
margin-bottom: 24px;
}
.container h4 {
text-align: center;
}
.container a {
cursor: pointer;
}
.container .wj-flexchart {
border: none;
}
.container {
border: 1px solid #e4e4e4;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexChart Column with Drill-down</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
import * as wjCore from '@mescius/wijmo';
// IMF estimates GDP(nominal) between 2020 and 2023
// https://en.wikipedia.org/wiki/List_of_countries_by_past_and_projected_GDP_(nominal)
export function getData() {
let data = [
{ country: 'United States', continent: 'North America', year: 2020, gdp: 22289 },
{ country: 'United States', continent: 'North America', year: 2021, gdp: 23096 },
{ country: 'United States', continent: 'North America', year: 2022, gdp: 23874 },
{ country: 'United States', continent: 'North America', year: 2023, gdp: 24670 },
{ country: 'China', continent: 'Asia', year: 2020, gdp: 15461 },
{ country: 'China', continent: 'Asia', year: 2021, gdp: 16768 },
{ country: 'China', continent: 'Asia', year: 2022, gdp: 18131 },
{ country: 'China', continent: 'Asia', year: 2023, gdp: 19580 },
{ country: 'Japan', continent: 'Asia', year: 2020, gdp: 5371 },
{ country: 'Japan', continent: 'Asia', year: 2021, gdp: 5522 },
{ country: 'Japan', continent: 'Asia', year: 2022, gdp: 5714 },
{ country: 'Japan', continent: 'Asia', year: 2023, gdp: 5907 },
{ country: 'Gemany', continent: 'Europe', year: 2020, gdp: 4331 },
{ country: 'Gemany', continent: 'Europe', year: 2021, gdp: 4523 },
{ country: 'Gemany', continent: 'Europe', year: 2022, gdp: 4736 },
{ country: 'Gemany', continent: 'Europe', year: 2023, gdp: 4937 },
{ country: 'India', continent: 'Asia', year: 2020, gdp: 3258 },
{ country: 'India', continent: 'Asia', year: 2021, gdp: 3586 },
{ country: 'India', continent: 'Asia', year: 2022, gdp: 3941 },
{ country: 'India', continent: 'Asia', year: 2023, gdp: 4329 },
{ country: 'France', continent: 'Europe', year: 2020, gdp: 2979 },
{ country: 'France', continent: 'Europe', year: 2021, gdp: 3100 },
{ country: 'France', continent: 'Europe', year: 2022, gdp: 3234 },
{ country: 'France', continent: 'Europe', year: 2023, gdp: 3363 },
{ country: 'United Kindom', continent: 'Europe', year: 2020, gdp: 2912 },
{ country: 'United Kindom', continent: 'Europe', year: 2021, gdp: 3012 },
{ country: 'United Kindom', continent: 'Europe', year: 2022, gdp: 3135 },
{ country: 'United Kindom', continent: 'Europe', year: 2023, gdp: 3257 },
{ country: 'Italy', continent: 'Europe', year: 2020, gdp: 2191 },
{ country: 'Italy', continent: 'Europe', year: 2021, gdp: 2255 },
{ country: 'Italy', continent: 'Europe', year: 2022, gdp: 2329 },
{ country: 'Italy', continent: 'Europe', year: 2023, gdp: 2395 },
{ country: 'Brazil', continent: 'South America', year: 2020, gdp: 2027 },
{ country: 'Brazil', continent: 'South America', year: 2021, gdp: 2129 },
{ country: 'Brazil', continent: 'South America', year: 2022, gdp: 2237 },
{ country: 'Brazil', continent: 'South America', year: 2023, gdp: 2351 },
{ country: 'Canada', continent: 'North America', year: 2020, gdp: 1937 },
{ country: 'Canada', continent: 'North America', year: 2021, gdp: 2053 },
{ country: 'Canada', continent: 'North America', year: 2022, gdp: 2185 },
{ country: 'Canada', continent: 'North America', year: 2023, gdp: 2321 },
{ country: 'South Korea', continent: 'Asia', year: 2020, gdp: 1781 },
{ country: 'South Korea', continent: 'Asia', year: 2021, gdp: 1864 },
{ country: 'South Korea', continent: 'Asia', year: 2022, gdp: 1959 },
{ country: 'South Korea', continent: 'Asia', year: 2023, gdp: 2054 },
{ country: 'Russia', continent: 'Europe', year: 2020, gdp: 1683 },
{ country: 'Russia', continent: 'Europe', year: 2021, gdp: 1719 },
{ country: 'Russia', continent: 'Europe', year: 2022, gdp: 1757 },
{ country: 'Russia', continent: 'Europe', year: 2023, gdp: 1818 },
{ country: 'Spain', continent: 'Europe', year: 2020, gdp: 1550 },
{ country: 'Spain', continent: 'Europe', year: 2021, gdp: 1616 },
{ country: 'Spain', continent: 'Europe', year: 2022, gdp: 1690 },
{ country: 'Spain', continent: 'Europe', year: 2023, gdp: 1758 },
{ country: 'Australia', continent: 'Oceania', year: 2020, gdp: 1541 },
{ country: 'Australia', continent: 'Oceania', year: 2021, gdp: 1615 },
{ country: 'Australia', continent: 'Oceania', year: 2022, gdp: 1700 },
{ country: 'Australia', continent: 'Oceania', year: 2023, gdp: 1794 },
{ country: 'Mexico', continent: 'North America', year: 2020, gdp: 1306 },
{ country: 'Mexico', continent: 'North America', year: 2021, gdp: 1376 },
{ country: 'Mexico', continent: 'North America', year: 2022, gdp: 1449 },
{ country: 'Mexico', continent: 'North America', year: 2023, gdp: 1526 },
{ country: 'Indonesia', continent: 'Asia', year: 2020, gdp: 1175 },
{ country: 'Indonesia', continent: 'Asia', year: 2021, gdp: 1259 },
{ country: 'Indonesia', continent: 'Asia', year: 2022, gdp: 1349 },
{ country: 'Indonesia', continent: 'Asia', year: 2023, gdp: 1446 },
{ country: 'Netherlands', continent: 'Europe', year: 2020, gdp: 980 },
{ country: 'Netherlands', continent: 'Europe', year: 2021, gdp: 1021 },
{ country: 'Netherlands', continent: 'Europe', year: 2022, gdp: 1065 },
{ country: 'Netherlands', continent: 'Europe', year: 2023, gdp: 1106 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2020, gdp: 815 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2021, gdp: 835 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2022, gdp: 860 },
{ country: 'Saudi Arabia', continent: 'Asia', year: 2023, gdp: 889 },
{ country: 'Nigeria', continent: 'Africa', year: 2020, gdp: 504 },
{ country: 'Nigeria', continent: 'Africa', year: 2021, gdp: 572 },
{ country: 'Nigeria', continent: 'Africa', year: 2022, gdp: 649 },
{ country: 'Nigeria', continent: 'Africa', year: 2023, gdp: 736 },
{ country: 'Argentina', continent: 'South America', year: 2020, gdp: 444 },
{ country: 'Argentina', continent: 'South America', year: 2021, gdp: 476 },
{ country: 'Argentina', continent: 'South America', year: 2022, gdp: 508 },
{ country: 'Argentina', continent: 'South America', year: 2023, gdp: 540 },
{ country: 'South Africa', continent: 'South America', year: 2020, gdp: 403 },
{ country: 'South Africa', continent: 'South America', year: 2021, gdp: 419 },
{ country: 'South Africa', continent: 'South America', year: 2022, gdp: 438 },
{ country: 'South Africa', continent: 'South America', year: 2023, gdp: 456 },
{ country: 'Colombia', continent: 'South America', year: 2020, gdp: 367 },
{ country: 'Colombia', continent: 'South America', year: 2021, gdp: 382 },
{ country: 'Colombia', continent: 'South America', year: 2022, gdp: 400 },
{ country: 'Colombia', continent: 'South America', year: 2023, gdp: 422 },
{ country: 'Chile', continent: 'South America', year: 2020, gdp: 352 },
{ country: 'Chile', continent: 'South America', year: 2021, gdp: 378 },
{ country: 'Chile', continent: 'South America', year: 2022, gdp: 404 },
{ country: 'Chile', continent: 'South America', year: 2023, gdp: 433 },
{ country: 'Egypt', continent: 'Africa', year: 2020, gdp: 339 },
{ country: 'Egypt', continent: 'Africa', year: 2021, gdp: 359 },
{ country: 'Egypt', continent: 'Africa', year: 2022, gdp: 380 },
{ country: 'Egypt', continent: 'Africa', year: 2023, gdp: 414 },
{ country: 'Peru', continent: 'South America', year: 2020, gdp: 252 },
{ country: 'Peru', continent: 'South America', year: 2021, gdp: 266 },
{ country: 'Peru', continent: 'South America', year: 2022, gdp: 281 },
{ country: 'Peru', continent: 'South America', year: 2023, gdp: 297 },
{ country: 'New Zealand', continent: 'Oceania', year: 2020, gdp: 227 },
{ country: 'New Zealand', continent: 'Oceania', year: 2021, gdp: 242 },
{ country: 'New Zealand', continent: 'Oceania', year: 2022, gdp: 257 },
{ country: 'New Zealand', continent: 'Oceania', year: 2023, gdp: 272 },
{ country: 'Algeria', continent: 'Africa', year: 2020, gdp: 207 },
{ country: 'Algeria', continent: 'Africa', year: 2021, gdp: 212 },
{ country: 'Algeria', continent: 'Africa', year: 2022, gdp: 218 },
{ country: 'Algeria', continent: 'Africa', year: 2023, gdp: 228 }
];
//
return new wjCore.CollectionView(data, {
groupDescriptions: ['year', 'continent', 'country']
});
}
//
// get the group data for a selected point
export function getGroupData(group) {
// get items for this group, aggregate by sales
let arr = [];
group.groups.forEach(function (g) {
arr.push({
name: g.name,
gdp: g.getAggregate(wijmo.Aggregate.Sum, 'gdp'),
group: g
});
});
//
// return a new collection view sorted by sales
return new wjCore.CollectionView(arr, {
sortDescriptions: [
new wjCore.SortDescription('gdp', false)
]
});
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);